# Discord Decorators


![CRAN](https://img.shields.io/cran/l/devtools.svg?style=for-the-badge) ![CRAN](https://img.shields.io/badge/Built%20With-Typescript-yellow.svg?style=for-the-badge) ![CRAN](https://img.shields.io/badge/Linted%20By-tslint-purple.svg?style=for-the-badge) 
![Travis (.com) branch](https://img.shields.io/travis/com/tiehm/discord-decorators/master.svg?style=for-the-badge)


> This framework is made for users using typescript, documentation is lacking on the javascript part.

> This project is using typescript's decorator, you have to set the ``experimentalDecorators`` option to ``true`` in your tsconfig file.

You can find the [docs here](DOCS.md).

A simple framework for command and event registration with the support of Typescript's decorators.

## Features

- Simple to use
- Custom command handler
- Custom event handler
- Command recognition and message event built in
- Typescript decorators
- Configurable
- Many built in features like argument parsing

## Getting Started

Please look [here](.github/CONTRIBUTING.md) for details on how to get running on a dev environment.

### Prerequisites

What things you need to install the software and how to install them

```
npm i discord.js@11.4.2 --save
```

### Installing
Install with

```bash
npm i discordjs-decorators --save # yarn add discordjs-decorators
```

and install ``discord.js#11.42``

```bash
npm i discord.js --save # yarn add discord.js
```

You can now use ``discordjs-decorators`` in your project.

## Running the tests

### Unit tests
````bash
yarn only-test
````

### Code style

```bash
yarn lint 
```

### Implementation tests

> Important: You need to setup a config(.js) file in the ``test`` folder which exports a JSON object with a token and owner property.

````bash
yarn test:discord
````

## Built With

* [discord.js](https://www.npmjs.com/package/discord.js) - Discord API library
* [Typescript](https://www.typescriptlang.org/) - Language used
* [glob](https://www.npmjs.com/package/glob) - Used to find files

## Contributing

Please read [CONTRIBUTING.md](.github/CONTRIBUTING.md) for details.

## License

This project is licensed under the [GNU General Public License v2.0](LICENCE).

## Acknowledgments

Inspiration from [yamdbf](https://github.com/yamdbf/core).

Contribution format from [discord.js](https://github.com/discordjs/discord.js)
