"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Set values to the Command class
 * @param key {string}
 * @param value
 * @private
 */
function _setMetaData(key, value) {
    return function (target) {
        if (key === 'usage') {
            Object.defineProperty(target.prototype, 'usage', {
                value: value.usage,
                configurable: true,
                enumerable: true,
                writable: true,
            });
            if (value.desc) {
                Object.defineProperty(target.prototype, 'desc', {
                    value: value.desc,
                    configurable: true,
                    enumerable: true,
                    writable: true,
                });
            }
            return target;
        }
        if (key === 'only') {
            for (const val of value) {
                Object.defineProperty(target.prototype, `${val}Only`, {
                    value: true,
                    configurable: true,
                    enumerable: true,
                    writable: true,
                });
            }
            return target;
        }
        if (!target.prototype.name) {
            Object.defineProperty(target.prototype, 'name', {
                value: target.name.toLowerCase(),
                configurable: true,
                enumerable: true,
                writable: true,
            });
        }
        Object.defineProperty(target.prototype, key, {
            value,
            configurable: true,
            enumerable: true,
            writable: true,
        });
        return target;
    };
}
exports._setMetaData = _setMetaData;
//# sourceMappingURL=CommandDecorators.js.map