"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CommandDecorators_1 = require("../CommandDecorators");
/**
 * Restrict the command to specific roles only
 * @param values {Snowflake[]|String[]} Role ID(s) or Role Name(s)
 */
function RestrictedRoles(...values) {
    const arr = [];
    for (const value of values) {
        arr.push({ type: 'role', id: value, name: value });
    }
    return CommandDecorators_1._setMetaData('restricted', arr);
}
exports.RestrictedRoles = RestrictedRoles;
//# sourceMappingURL=restrictedRoles.js.map