"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CommandDecorators_1 = require("../CommandDecorators");
/**
 * Restrict the command to specific users only
 * @param values {Snowflake[]} User ID(s)
 */
function RestrictedUsers(...values) {
    const arr = [];
    for (const value of values) {
        arr.push({ type: 'user', id: value });
    }
    return CommandDecorators_1._setMetaData('restricted', arr);
}
exports.RestrictedUsers = RestrictedUsers;
//# sourceMappingURL=restrictedUsers.js.map