import { Client, ClientOptions } from 'discord.js';
import { CommandRegistry } from '../command/CommandRegistry';
import { EventRegistry } from '../event/EventRegistry';
interface ISilentClientConfig {
    token: string;
    prefix?: string | string[];
    mentionPrefix?: boolean;
    owner: string;
    commandDir: string;
    eventDir: string;
    notFoundError: string;
    baseDir?: string;
    base?: boolean;
    waitForMessage?: boolean;
}
export declare class SilentClient extends Client {
    readonly owner: string;
    commands: CommandRegistry<SilentClient>;
    events: EventRegistry<SilentClient>;
    readonly baseDir: string;
    readonly prefix?: string | string[];
    private readonly mentionPrefix;
    private readonly _token;
    private readonly _commandLoader;
    private readonly _eventLoader;
    private readonly commandDir;
    private readonly eventDir;
    private readonly ownerID;
    private readonly notFoundError?;
    private readonly base;
    private readonly waitForMessage;
    constructor(config: ISilentClientConfig, clientConfig?: ClientOptions);
    /**
     * Starts the Bot and logs into the Discord API
     */
    start(): this;
    getDefaultPrefix(): string;
    /**
     * Handle an incoming message
     * @private
     * @param msg {Message}
     */
    private messageHandle;
    private findCommand;
    private checkForDuplicateCommand;
}
export {};
