"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = require("../../..");
const DetailedHelpEmbed_1 = require("../../../util/embed/DetailedHelpEmbed");
const HelpEmbed_1 = require("../../../util/embed/HelpEmbed");
const format_1 = require("../../../util/format");
const Command_1 = require("../Command");
let Help = class Help extends Command_1.Command {
    run(msg, args) {
        return __awaiter(this, void 0, void 0, function* () {
            if (args[0]) {
                const searchCmd = args[0];
                const command = this._client.commands.get(searchCmd) ||
                    this._client.commands.find(fc => fc.aliases.includes(searchCmd));
                if (!command || command.hidden)
                    return msg.channel.send('Command not found.');
                const name = command.name;
                const aliases = command.aliases;
                const nsfw = command.nsfw;
                const desc = command.desc;
                const usage = format_1.format(command.usage, this._client.getDefaultPrefix(), 'prefix');
                const guildOnly = command.guildOnly;
                const ownerOnly = command.ownerOnly;
                const example = command.example;
                yield msg.channel.send(new DetailedHelpEmbed_1.DetailedHelpEmbed(name, aliases, desc, usage, example, nsfw, guildOnly, command.dmOnly, command.restricted, ownerOnly, this._client, command.name));
            }
            else {
                const embed = new HelpEmbed_1.HelpEmbed();
                const commands = this._client.commands.filter(c => c.name !== 'help' && !c.hidden).map((value) => {
                    return {
                        name: value.name,
                        alias: value.aliases.join(', '),
                        desc: value.desc
                    };
                });
                for (const command of commands) {
                    embed.addField(`${command.name} [${command.alias}]`, command.desc, true);
                }
                yield msg.channel.send(embed);
            }
        });
    }
};
Help = __decorate([
    __1.Usage('<prefix>help [command]', 'Help command.'),
    __1.GuildOnly()
], Help);
exports.Help = Help;
//# sourceMappingURL=help.js.map