"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
class EventRegistry extends discord_js_1.Collection {
    constructor(client) {
        super();
        this.client = client;
    }
    _registerInternal(event) {
        if (this.has(event.name)) {
            this.delete(event.name);
        }
        this.set(event.name, event);
        event._init(this.client);
        if (event.name !== 'message')
            this.client[event.once ? 'once' : 'on'](event.name, (...args) => event.run(args));
    }
}
exports.EventRegistry = EventRegistry;
//# sourceMappingURL=EventRegistry.js.map